local leftkey = "["
local rightkey = "]"
local bothkey = "o"
local Bind = "i" 
local LightState = {}
local BlinkT = {}
local BlinkS = {}
local function Blink( vehicle, how, l1, l2 )
	if isElement( vehicle ) then
		if not BlinkS[vehicle] and how == 1 then
			setVehicleLightState ( vehicle, l1, 1 )
			setVehicleLightState ( vehicle, l2, 1 )
			BlinkS[vehicle] = true
		elseif BlinkS[vehicle] and how == 1 then
			setVehicleLightState ( vehicle, l1, 0 )
			setVehicleLightState ( vehicle, l2, 0 )
			BlinkS[vehicle] = false
		elseif not BlinkS[vehicle] and how == 2 then
			setVehicleLightState ( vehicle, l2, 1 )
			BlinkS[vehicle] = true
		elseif BlinkS[vehicle] and how == 2 then
			setVehicleLightState ( vehicle, l2, 0 )
			BlinkS[vehicle] = false
		elseif not BlinkS[vehicle] and how == 3 then
			setVehicleLightState ( vehicle, 0, 1 )
			setVehicleLightState ( vehicle, 1, 1 )
			setVehicleLightState ( vehicle, 2, 1 )
			setVehicleLightState ( vehicle, 3, 1 )
			BlinkS[vehicle] = true
		elseif BlinkS[vehicle] and how == 3 then
			setVehicleLightState ( vehicle, 0, 0 )
			setVehicleLightState ( vehicle, 1, 0 )
			setVehicleLightState ( vehicle, 2, 0 )
			setVehicleLightState ( vehicle, 3, 0 )
			BlinkS[vehicle] = false
		elseif not BlinkS[vehicle] and how == 4 then
			setVehicleLightState ( vehicle, 0, 0 )
			setVehicleLightState ( vehicle, 1, 0 )
			setVehicleLightState ( vehicle, 2, 0 )
			setVehicleLightState ( vehicle, 3, 0 )
			BlinkS[vehicle] = true
		elseif BlinkS[vehicle] and how == 4 then
			setVehicleLightState ( vehicle, 0, 1 )
			setVehicleLightState ( vehicle, 1, 1 )
			setVehicleLightState ( vehicle, 2, 1 )
			setVehicleLightState ( vehicle, 3, 1 )
			BlinkS[vehicle] = false
		end
	else
		if getElementData(vehicle, "blinker") ~= "lock" and getElementData(vehicle, "blinker") ~= "unlock" then
			killTimer( BlinkT[vehicle] )
		end
		BlinkT[vehicle] = nil
		BlinkS[vehicle] = nil
	end
end

local function DestroyVehicleBlinker( vehicle )
	if getElementData(vehicle, "blinker") ~= "lock" and getElementData(vehicle, "blinker") ~= "unlock" then
		killTimer( BlinkT[vehicle] )
	end
	BlinkT[vehicle] = nil
	BlinkS[vehicle] = nil
	setVehicleLightState( vehicle, 0, LightState[vehicle][1] )
	setVehicleLightState( vehicle, 1, LightState[vehicle][2] )
	setVehicleLightState( vehicle, 3, 0 )
	setVehicleLightState( vehicle, 2, 0 )
	setVehicleOverrideLights( vehicle, 0 )
	LightState[vehicle] = nil
end

local function Blinker( vehicle, mode )
	if vehicle then
		if not mode and BlinkT[vehicle] then
			DestroyVehicleBlinker( vehicle )
		else
			setVehicleOverrideLights( vehicle, 2 )
			local a,b = getVehicleLightState( vehicle, 0 ), getVehicleLightState( vehicle, 1 )
			LightState[vehicle] = { a, b }
			if mode == leftkey then
				setVehicleLightState( vehicle, 1, 1 )
				setVehicleLightState( vehicle, 2, 1 )
				if a == 0 then
					BlinkT[vehicle] = setTimer( Blink, 400, 0, vehicle, 1, 0, 3 )
				elseif a == 1 then
					BlinkT[vehicle] = setTimer( Blink, 400, 0, vehicle, 2, 0, 3 )
				end
			elseif mode == rightkey then
				setVehicleLightState( vehicle, 0, 1 )
				setVehicleLightState( vehicle, 3, 1 )
				if b == 0 then
					BlinkT[vehicle] = setTimer( Blink, 400, 0, vehicle, 1, 1, 2 )
				elseif b == 1 then
					BlinkT[vehicle] = setTimer( Blink, 400, 0, vehicle, 2, 1, 2 )
				end
			elseif mode == bothkey then
				BlinkT[vehicle] = setTimer( Blink, 400, 0, vehicle, 3, 0, 1 )
			elseif mode == "lock" then
				BlinkT[vehicle] = setTimer( Blink, 100, 2, vehicle, 4, 1, 0 )
			elseif mode == "unlock" then
				BlinkT[vehicle] = setTimer( Blink, 100, 4, vehicle, 4, 1, 0 )
			end
		end
	end
end

local MasterWindow
local hood
local trunk
local fleft
local fright
local rleft
local rright
local function init()
	local screenW, screenH = guiGetScreenSize()
	MasterWindow = guiCreateWindow ( (screenW - 260) / 2, (screenH - 135) / 2, 260, 135, "Панель управления", false )
	guiSetVisible( MasterWindow, false ) 
	guiWindowSetSizable( MasterWindow, false )
	hood = guiCreateButton( 90, 30, 75, 20, "Капот", false, MasterWindow )
	trunk = guiCreateButton( 90, 105, 75, 20, "Багажник", false, MasterWindow )
	fleft = guiCreateButton( 15, 55, 110, 20, "Левая-Передняя", false, MasterWindow )
	fright = guiCreateButton( 135, 55, 110, 20, "Правая-Передняя", false, MasterWindow )
	rleft = guiCreateButton( 15, 80, 110, 20, "Левая-Задняя", false, MasterWindow )
	rright = guiCreateButton( 135, 80, 110, 20, "Правая-Задняя", false, MasterWindow )
	for i, vehicle in ipairs ( getElementsByType("vehicle") ) do
		local _blinker = getElementData( vehicle, "blinker" )
		if _blinker then
			Blinker( vehicle, _blinker )
		end
	end
	addEventHandler ( "onClientResourceStop", resourceRoot, function()
		for vehicle in pairs ( BlinkT ) do
			DestroyVehicleBlinker( vehicle )
		end
	end)
	addEventHandler( "onClientElementDataChange", root, function ( dataName )
		if isElement( source ) and dataName == "blinker" and getElementType( source ) == "vehicle" then
			Blinker( source, getElementData( source, "blinker" ) )
		end
	end)
	addEventHandler( "onClientPlayerVehicleExit", localPlayer, function ()
		guiSetVisible( MasterWindow, false )
		showCursor( false )
	end)
end

addEventHandler ( "onClientResourceStart", resourceRoot, function()
	setTimer( init, 1000, 1 )
end)

local function AbrirGUI()
	local theVehicle = getPedOccupiedVehicle( localPlayer )
	if theVehicle and getVehicleController( theVehicle ) == localPlayer then
		if isPedInVehicle( localPlayer ) then
			if (guiGetVisible( MasterWindow ) == false) then
				guiSetVisible( MasterWindow, true )
				showCursor( true )
			else
				guiSetVisible( MasterWindow, false )
				showCursor( false )
			end
		end
	end
end
bindKey( Bind, "down", AbrirGUI )

local function onGuiClick ()
    if source == hood then
        triggerServerEvent( "vehDoorPanel", resourceRoot, 0 )
    elseif source == trunk then
        triggerServerEvent( "vehDoorPanel", resourceRoot, 1 )
    elseif source == fleft then
        triggerServerEvent( "vehDoorPanel", resourceRoot, 2 )
    elseif source == fright then
        triggerServerEvent( "vehDoorPanel", resourceRoot, 3 )
    elseif source == rleft then
        triggerServerEvent( "vehDoorPanel", resourceRoot, 4 )
    elseif source == rright then
        triggerServerEvent( "vehDoorPanel", resourceRoot, 5 )
    end
end
addEventHandler( "onClientGUIClick", resourceRoot, onGuiClick )