local function vehDoorPanel( i )
	if not i then return end
	if i < 0 or i > 5 then return end
	local vehicle = getPedOccupiedVehicle( client )
	if not vehicle then return end
    if getVehicleDoorOpenRatio ( vehicle, i ) == 0 then
        setVehicleDoorOpenRatio( vehicle, i, 1, 1500 )
    else
        setVehicleDoorOpenRatio( vehicle, i, 0, 500 )
    end
end
addEvent("vehDoorPanel", true)
addEventHandler("vehDoorPanel", resourceRoot, vehDoorPanel)

function Blinker(player,mode)
	local vehicle = getPedOccupiedVehicle(player)
	if vehicle and getVehicleController(vehicle) == player then
		local _blinker = getElementData(vehicle, "blinker")
		if _blinker then
			removeElementData(vehicle, "blinker")
		else
			setElementData(vehicle, "blinker", mode)
		end
	end
end

function toggleVehicleEngine(player)
	if isPedInVehicle(player) then
		local theVehicle = getPedOccupiedVehicle(player)
		local veh_type = getVehicleType(theVehicle)
		if veh_type == "Train" or veh_type == "BMX" then return end
		if getVehicleController( theVehicle ) ~= player or getElementHealth( theVehicle ) <= 255.5 or ( benz and benz <= 0 ) then return end
		setVehicleEngineState( theVehicle, getVehicleEngineState(theVehicle) == false )
	end
end

function Light(player)
	if isPedInVehicle(player) then
		local theVehicle = getPedOccupiedVehicle(player)
		local veh_type = getVehicleType(theVehicle)
		if veh_type == "Train" or veh_type == "BMX" then return end
		if getVehicleController( theVehicle ) ~= player then return end
		 if ( getVehicleOverrideLights ( theVehicle ) ~= 2 ) then
			setVehicleOverrideLights ( theVehicle, 2 )
		else
			setVehicleOverrideLights ( theVehicle, 1 )
		end
	end
end

function AssignBinds(player)
	bindKey ( player, leftkey, "down", Blinker )
	bindKey ( player, rightkey, "down", Blinker )
    bindKey ( player, bothkey, "down", Blinker )
	bindKey ( player, "l", "down", Light )
	bindKey ( player, "z", "down", toggleVehicleEngine )
end

function UnassignBinds(player)
	unbindKey ( player, leftkey, "down", Blinker )
	unbindKey ( player, rightkey, "down", Blinker )
	unbindKey ( player, bothkey, "down", Blinker )
	unbindKey ( player, "l", "down", Light )
	unbindKey ( player, "z", "down", toggleVehicleEngine )
end

addEventHandler ( "onVehicleEnter", root, function( player, seat )
    if seat == 0 then
	  setVehicleEngineState( source, true )
		if getVehicleEngineState( source ) == true then
		end
    end
end)

addEventHandler ( "onResourceStart", resourceRoot, function()
	for i, player in ipairs( getElementsByType("player") ) do
		AssignBinds( player )
	end
end)

addEventHandler ( "onResourceStop", resourceRoot, function()
	for i, vehicle in ipairs ( getElementsByType("vehicle") ) do
		removeElementData( vehicle, "blinker" )
	end
end)

function joinHandler()
	AssignBinds( source )
end
addEventHandler( "onPlayerJoin", root, joinHandler )

addEventHandler( "onVehicleRespawn", root, function ()
	removeElementData(source, "blinker")
end)

addEventHandler( "onElementDataChange", root, function(theName, theOldValue)
	if client and getElementType(source) == "vehicle" and theName == "blinker" then
		setElementData(source, theName, theOldValue)
	end
end)